function [ff,H,F,W,R,init_V] = ckm(xy,Y,theta,muz,taux,beta,delta,gamma,taul,psi,lb,rhoz,rrhox,ssigx,rrhol,ssigl,RR,option,restr,per)

spect = 1;
if isempty(per) == 1
    spect = 0;    
end

numval=size(xy,2);%the program is capable of taking in a matrix of values of parameters, in which case it returns a vector of function values

if numval > 1
    ff=zeros(1,numval);
end

for ii = 1:numval
    
    xx=xy(:,ii);
    
    [rhol,sigl,sigz,rhox,sigx,R] = map(xx,rrhol,ssigl,rrhol,ssigx,RR,restr);
    
    chk=0;%check all analytic derivatives used to solve the model, by evaluating the numerical analogs
    
    [l,c,k,y,A,B,P,h0,h1] = solvemodel(theta,muz,taux,beta,delta,gamma,taul,psi,lb,rhoz,rhox,rhol,chk);
    
    [F,H,W] = kalmanmat(h0,h1,A,B,theta,delta,gamma,muz,k,c,y,l,sigz,sigl,sigx,P,option);
    
    [m,T]=size(Y);
    if m < 4
        H=H([1:m],:);
    end
   
    if spect == 0;%evaluate the exact gaussian density function
        
        n=length(B);
        
        alf=zeros(m,1);
        
        init_x=zeros(2+2*n,1);
        
        [init_V] = uncondvar(W,F,n);
        
        cchk=0;
        if cchk == 1
            ez=init_V-F*init_V*F'-W;
            if max(max(abs(ez))) > .1e-10
                error('fatal (statespace) unconditional variance of state not accurate')
            end
        end
        
        [loglik] = mykalman(Y,F,H,W,R,init_x,init_V,alf);
        
        floglik  =   -loglik;
        
    elseif spect == 1%evaluate the spectral approximation to the likelihood (equation (3) in c-v with simplification in (10))
        
        [floglik] = getspectff(T,F,H,W,per); 
        floglik   = -floglik;
        init_V=[];
        R=[];
        
    end
    
    ff(ii)=floglik;
    
end