addpath c:\projects\pfann


load aceldata vardata

lh=vardata(:,5);
lcy=vardata(:,7);

hours=exp(lh);
hours=hours*0.2079/mean(hours);

tax=1-(hours./(1-hours)).*exp(lcy)*2.5/(1-0.33);

date=1959.25:.25:2001.75;
T=length(date)-1;
X=[ones(T,1) tax(1:T)];
Y=tax(2:end);
bet=(X'*X)\(X'*Y);
er=Y-X*bet;
Yhat=X*bet;
serr=std(er);
ttax=zeros(length(tax),1);
for ii = 1:length(tax)
    ttax(ii)=tax(ii)-0.242;
end
X=ttax(1:T);
Y=ttax(2:end);

bet1=(X'*X)\(X'*Y);
er1=Y-X*bet1;
serr1=std(er1);

nlags=1;
s=5;
test=1;
[qstat,dof,pvalue] = mkqmv(er1,s,nlags,test);

[pvalue] = monteerr(er1,bet(1));

tj=1:length(er1)-1;
tj1=2:length(er1);
aa=corrcoef(er1(tj),er1(tj1));

subplot(221)
plot(date(2:end),Y,date(2:end),er)
legend('Estimated labor tax wedge','Fitted Residuals')
title('Figure 1a')
axis tight
subplot(222)
plot(date,hours./(1-hours))
title('Figure 1b: labor to leisure ratio')
axis tight
subplot(223)
plot(date,lcy)
title('Figure 1c: log, Consumption to Output Ratio')
axis tight

load moredata 
lam=1600;
lcy=log(cy(end-170:end));
liy=log(iy(end-170:end));
lh=lhours(end-170:end);
ly=log(output(end-170:end));

[A,B]=hpmatrix(ly,lam);

lyc=B*ly;
lcc=lyc+B*lcy;
lic=lyc+B*liy;
lhc=B*lh;

sc=std(lcc);
sy=std(lyc);
si=std(lic);
sh=std(lhc);
a=corrcoef(lyc-lhc,lhc);
lag=2;
thet=1;
l=7;
[V,rnw,snsw,B,S,T]=corr(lyc-lhc,lhc,lag,thet,l);
sprintf(' correlation, productivity and hours = %6.5f, standard error = %6.5f\n',B(1,3),B(2,3))
[V,rnw,snsw,B,S,T]=corr(lcc,lyc,lag,thet,l);
sprintf(' standard deviation of consumption relative to output = %6.5f, standard error = %6.5f\n',B(1,6),B(2,6))
[V,rnw,snsw,B,S,T]=corr(lic,lyc,lag,thet,l);
sprintf(' standard deviation of investment relative to output = %6.5f, standard error = %6.5f\n',B(1,6),B(2,6))
[V,rnw,snsw,B,S,T]=corr(lhc,lyc,lag,thet,l);
sprintf(' standard deviation of hours relative to output = %6.5f, standard error = %6.5f\n',B(1,6),B(2,6))

sprintf(' rel standard deviation, consumption = %6.5f, investment = %6.5f, hours = %6.5f\n',sc/sy,si/sy,sh/sy)


plot(date(2:end),er)