function  [sarcoef,macoef,const,erz]=estsvar(data,sarlags,malags,hascon);
 %estimate a scalar autoregression with moving average terms. 
 % y_i (t) = const_i +  sarcoef(1)*y_i(t-1) + ... + sarcoef(n)*y_i(t-n) + u_i(t) + MA_k * u(t-k)
 
if nargin < 4;
    hascon = 0;
end

 %how large is data. 
[bigt,nvars] = size(data);
 
%estimate a VAR with lots of lags. with the multiple controlled by lagmult;
% lagmult = 4; 
% [beta,sigma,uz,vcovbeta]=estimatevar(data,lagmult*(sarlags+malags),hascon);
%     % pad the residuals uz to account for us not seeing the forecast errors for the
%   % first  lagmult*(sarlags+malags) observations;
%   uz = [zeros(lagmult*(sarlags+malags),nvars); uz];
  
lagmult = min(floor(sqrt(bigt)),500);

  [beta,sigma,uz,vcovbeta]=estimatevar(data,lagmult,hascon);
%     % pad the residuals uz to account for us not seeing the forecast errors for the
%   % first  lagmult*(sarlags+malags) observations;
    uz = [zeros(lagmult,nvars); uz];


% [g1,g2,s2,ma2,v2] = estvarma(Y-repmat(mean(Y),length(Y),1),p,q)
% [xx3alt(:,zm)] = coef2opt(s2,ma2,v2);
% [loglikmle3alt(:,zm)] = SARMA(xx3(:,zm),p,q,N,Y);

  %dependent variable.
   yy =  data((sarlags+1:bigt),:);  

   %explanatory variable
  
 xx = zeros(bigt-sarlags,sarlags*nvars);
 for xcntr = sarlags:-1:1;
     xx(:,((sarlags-xcntr)*nvars)+(1:nvars)) = data(xcntr:(bigt-sarlags+xcntr-1),:);
 end;

  %for sizing pretend that malags has one extra lag
    malags = malags+1;

 
 uu = zeros(bigt-malags,(malags)*nvars);
 for xcntr = malags:-1:1;
      uu(:,((malags-xcntr)*nvars)+(1:nvars)) = uz(xcntr:(bigt-malags+xcntr-1),:);
 end;
 %throw away the time t observation, just want lags. 
 uu = uu(:,(nvars+1):end);
  
 if sarlags<malags;
     xx = xx((malags-sarlags+1):end,:);
     yy = yy((malags-sarlags+1):end,:);

 elseif sarlags>malags;
     uu = uu((sarlags-malags+1):end,:);
 end
 
 
 %now to stack stuff;
 syy  = yy(:);
 sxx  = reshape(xx,2*size(xx,1),size(xx,2)/2);
 suu  = kron(eye(nvars),uu);
 
 if hascon
    hc =   kron(eye(nvars),ones(size(xx,1),1));
 else
     hc = [];
 end
 
 %now to do the stacked regression. 
 gamvec = [hc sxx suu]\syy;
  
 if hascon
 const = gamvec(1:nvars);
 gamvec = gamvec((nvars+1):end);
 else
     const = [];
 end
 
 sarcoef = gamvec(1:sarlags);
 gamvec = gamvec((sarlags+1):end);
 %reset malags back to its true value
 malags =malags-1;

 macoef =  zeros(nvars,malags*nvars);

 for zx = 1:nvars;
     macoef(zx,:) = gamvec((zx-1)*(malags*nvars)+(1:(malags*nvars)))';
 end

 erz = yy;
 for zx=1:nvars;
     if hascon;
     erz(:,zx) =  yy(:,zx) - const(zx) - xx(:,zx:nvars:end)*sarcoef-uu*macoef(zx,:)';
     else
     erz(:,zx) =  yy(:,zx) - xx(:,zx:nvars:end)*sarcoef-uu*macoef(zx,:)';
     end;
 end
 
  