function [l,c] = ffindlabor(k,kp,mu,taul,gamma,theta,delta,muz,lb,psi);

%given k, kp, epsz, taul, this solves for labor and consumption using the
%intratemporal euler equation and the resource constraint

l0=.00001;
lu=(1-.00001)*lb;
[ff0] = findlabor(l0,k,kp,mu,taul,gamma,theta,delta,muz,lb,psi);
[ffu] = findlabor(lu,k,kp,mu,taul,gamma,theta,delta,muz,lb,psi);

if ff0*ffu > 0
    error('fatal (ffindlabor) interval does not bracket solution for labor')
end
options=optimset;
[x,fval,exitflag] = fzero('findlabor',[l0,lu],options,k,kp,mu,taul,gamma,theta,delta,muz,lb,psi);
if abs(fval) > .1e-10 
    error('fatal (ffindlabor) failed to find labor')
end
if exitflag ~= 1
    error('fatal (ffindlabor) failed to solve for labor')
end

l=x;

[c] = cons(k,kp,l,mu,gamma,theta,delta,muz);