function [floglik,SPECT,omm] = getspectff(T,F,H,W,per)
[n,m]=size(F);

if round(T/2)*2 ~= T
    error('fatal (getspectff) set to work with a real value of T')
end

for j = 0:T/2    
    
    om=2*pi*j/T; 
    omm(j+1)=om;
    
    S=(eye(n)-F*exp(-i*om));
    Si=inv(S);
    SPECT(:,:,j+1)=H*Si*W*Si'*H';
    sp=(1/(2*pi))*H*Si*W*Si'*H';
    
    detsp=sp(1,1)*sp(2,2)-sp(1,2)*sp(2,1);    
    
    if sp(1,1) < 0 | sp(2,2) < 0 | detsp < .1e-14
        floglik=-7e12;
        return
    end
    
    if cond(sp) < .1e-10
        floglik=-8e12;
        return
    end
        
    L=( 2*log(2*pi) + log(detsp) + trace(inv(sp)*per(:,:,j+1)) )/2;
    
    if j == 0
        floglik=L;
    end
    if j > 0 & j < T/2
        floglik=floglik+2*L;
    end
    if j == T/2
        floglik=floglik+L;
    end  
    
end

if abs(imag(floglik)/real(floglik)) > .1e-8
    error('fatal (getspectff) likelihood function value complex')
end

floglik=-real(floglik);