function [Cul,Cuh,Crl,Crh,VARu,VARr,omm] = getvar(T,sarcoef,macoef,v,ar,ma,vv,p,q,cut)

omcut=2*pi/cut;

m=size(macoef,1);
Cuh=zeros(2,2);
Crh=zeros(2,2);

if round(T/2)*2 ~= T
    error('fatal (getvar) T must be divisible by 2')
end
   
for j = 0:T/2
    
    omm(j+1)=2*pi*j/T;
    om=omm(j+1);
    
    a=1;
    aa=1;
    for ii = 1:p
        a=a-sarcoef(ii)*exp(-i*om*ii);
        aa=aa-ar(ii)*exp(-i*om*ii);
    end
    
    b=eye(m);
    bb=eye(m);
    for ii = 1:q
        b=b+macoef(:,(ii-1)*m+[1:m])*exp(-i*om*ii);
        bb=bb+ma(:,(ii-1)*m+[1:m])*exp(-i*om*ii);
    end
    
    Fr([1:m],[1:m],j+1)=b*v*b'/(a*a');%restricted reduced form
    Fu([1:m],[1:m],j+1)=bb*vv*bb'/(aa*aa');%unrestricted reduced form       
    
    if j == 0
        Cul=Fu([1:m],[1:m],j+1);
        Crl=Fr([1:m],[1:m],j+1);
        VARu(:,:,1)=Cul;
        VARr(:,:,1)=Crl;
    end
    if j > 0 & j < T/2
        
        if om < omcut
            Cul=Cul+2*real(Fu([1:m],[1:m],j+1));
            Crl=Crl+2*real(Fr([1:m],[1:m],j+1));
        else
            Cuh=Cuh+2*real(Fu([1:m],[1:m],j+1));
            Crh=Crh+2*real(Fr([1:m],[1:m],j+1));;
        end
        
        VARr(:,:,j+1)=VARr(:,:,j)+2*real(Fr([1:m],[1:m],j+1));
        VARu(:,:,j+1)=VARu(:,:,j)+2*real(Fu([1:m],[1:m],j+1));
        
    elseif j == T/2
        
        Cuh=Cuh+Fu([1:m],[1:m],j+1);
        Crh=Crh+Fr([1:m],[1:m],j+1);
        
        VARr(:,:,j+1)=VARr(:,:,j)+real(Fr([1:m],[1:m],j+1));
        VARu(:,:,j+1)=VARu(:,:,j)+real(Fu([1:m],[1:m],j+1));
        
    end  
    
end

if max(max(abs(imag(Cuh)))) > .1e-10 | max(max(abs(imag(Crh)))) > .1e-10 | ...
        max(max(abs(imag(Cul)))) > .1e-10 | max(max(abs(imag(Crl)))) > .1e-10
    error('fatal (getvar) complex variance')
end

Cuh=real(Cuh)/T;
Cul=real(Cul)/T;
Crh=real(Crh)/T;
Crl=real(Crl)/T;
VARr(:,:,:)=VARr(:,:,:)/T;
VARu(:,:,:)=VARu(:,:,:)/T;