%this computes impulse response functions for the model
close all
clear all
setpath

%load up the parameter values:
params
lam=1600;
tau=[1 0
         1 1
         1  0];%specifies that investment responds to everything and labor only to second shock.
tau=ones(3,2);

%J=[1 2 ];
lngrun=1;%if = 1, do longrun identification; otherwise, do short run.
chk=0;%check all analytic derivatives used to solve the model, by evaluating the numerical analogs

%&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
if max(max(tau==0)) < 1 & lngrun ~= 1
    error('fatal (recursive) trying to do recursive identification in a model where it is not satisfied')
end
var=sigl^2/(1-rhol^2);
rhol=.6;
sigl=sqrt(1-rhol^2)*sqrt(var);

[A,B,P,a0,a1,a2,b0,b1,W,y,l,c,k] = solution(theta,muz,taux,beta,delta,gamma, ...
    taul,psi,lb,rhoz,rhox,rhol,tau,sigz,sigl,sigx,sig,chk);
frisch=(lb-l)/(sig*l);

h0=A(2,1);
h1=B(2,:);
A=A(1,1);
B=B(1,:);

T=40;

%get the responses to a technology shock
epsil=zeros(length(B),T);
epsil(1,1)=sigz;
[khat,lhat,s] = simulmodel(epsil,A,B,P,h0,h1,T);
yltrue=theta*(khat([1:end-1])-s(1,:))+(1-theta)*lhat-lhat;
ytruez=yltrue+lhat;
z=cumsum(s(1,:));
Yltrue=yltrue+z;
Ytruez=ytruez+z;


subplot(221)
plot(100*Ytruez)
ylabel('percent response')
title('Output Response to Technology')
subplot(222)
plot(100*lhat)
ylabel('percent response')
title('Hours Response to Technology')


%get the responses to a preference shock
epsil=zeros(length(B),T);
epsil(2,1)=sigl;
[khat,lhat,s] = simulmodel(epsil,A,B,P,h0,h1,T);
yltrue=theta*(khat([1:end-1])-s(1,:))+(1-theta)*lhat-lhat;
ytruelabor=yltrue+lhat;
z=cumsum(s(1,:));
Yltrue=yltrue+z;
Ytruelabor=ytruelabor+z;

subplot(223)
plot(100*Ytruelabor)
ylabel('percent response')
title('Output Response to Preference Shock')
subplot(224)
plot(100*lhat)
ylabel('percent response')
title('Hours Response to Preference Shock')

ss=['Response of Hours Worked and Output To Shocks, KP Example, \sigma = ',num2str(sig),', \rho_l = ',num2str(rhol)];
hout=suptitle(ss);
