%
%Parameter values are set in paramsnew.m.
% par = 1: 2-shock MLE
% par = 2: 2-shock CKM
% par = 3: 3-shock CKM
% par = 6: 3-shock MLE
%
% Whether you're working with the recursive version of the model or the one
% in which all period t decisions see all current period t shocks is determined by wether the line, tau=ones(3,2), has been commented out in the calling program (run.m or smallsample.m). If commented out, then we're working with the recursive version of the model. 
%
% run.m - this computes the plims for various lag lengths, and graphs the results. The plims can be based on long-run 
%              or short run restrictions.
% eggtest.m - this computes ratio of impact effects on employment and productivity of technology shock, to true value.
%             This is done for various values of persistence of labor shock.
% smallsample.m - this computes the small sample distribution of impulse response of hours to long-run shocks.
% solution.m - this uses the general solution strategy to solve the model. It allows for 'exotic' information sets.
% statespace - this puts CKM model in state space form and estimates it. 
% simszha.m - this takes the approach to invertibility of shocks described in Sims-Zha's forthcoming Macroeconomic Dynamics paper.
%
%     
% aceldata.mat - this contains the 171 by 10 matrix vardata, which contains the ACEL data used to compute the ACEL 10 
%    variable VAR. The order of the 10 variables is described in the ACEL manuscript:
%      growth, Pi
%      growth, y/n
%      inflation
%      capacity utilization
%      log, hours
%      log y/n - log real wage
%      log c/y
%      log i/y
%      Funds Rate
%      log P + log y - log mzm
%      
% ckmdata.m - this contains the CKM data on output growth, log hours, investment growth, gov't consumption growth
% estimate.m - this does the 'transparent' estimator of the exogenous shocks.     
% estimateSARMA - estimates a SARMA model by exact maximum likelihood
% runSARMA - runs estimation code (exact max likelihood or spectral approximation) for SARMA models and DSGE models
% fitting - results of running runSARMA
% findAR - given an MA representation, this computes a VAR of finite lags
% spectral - does analysis of models in spectral space.
% lowvariance - this is a simple example, to compute the fraction of
%               variance in log hours due to technology.

%estimatemodel this estimates the two-shock rbc model
%statespace.m - estimates models using maximum likelihood.
 
     