function [a0,a1,a2,b0,b1,W] = reducedform(A,B,muz,l,k,c,y,delta,theta,h0,h1,sigz,sigl,sigx)

%Y(t) = [dlog(y(t)/h(t)) log(h(t)) log(i(t)/y(t)) log(c(t)/y(t))]'

tau=zeros(1,size(h1,2));
tau(1)=1;

yk=theta+(1-theta)*h0;
ys=(1-theta)*h1-theta*tau;
i=(1-(1-delta)*exp(-muz))*k;
ik=(k/i)*(A-(1-delta)*exp(-muz));
is=(k/i)*(B+(1-delta)*exp(-muz)*tau);
ck=(y/c)*yk-(i/c)*ik;
cs=(y/c)*ys-(i/c)*is;

a0=[muz log(l) log(i/y) log(c/y)]';
a1=[theta*(1-h0) h0 ik-yk ck-yk]';
a2=[-theta*(1-h0) 0 0 0]';

b0=[(1-theta)*tau-theta*h1
    h1
    is-ys
    cs-ys];

b1=[theta*(tau+h1)
    zeros(3,size(h1,2))];


W=[sigz^2 0 0
    0 sigl^2 0
    0 0 sigx^2];

if size(h1,2) == 6

    WW=zeros(6,6);
    WW([1:3],[1:3])=W;
    W=WW;

elseif size(h1,2) ~= 6 & size(h1,2) ~=3

    error('fatal (reducedforms) dimension of s neither 6 nor 3')

end

