function [a0,a1,a2,b0,b1] = rform(A,B,theta,delta,gam,muz,k,c,y,l,def)
%                                         
%  X(t) = a0 + a1*khat(t) + a2*khat(t-1) + b0*s(t) + b1*s(t-1)
%

%def = 1, or no 11th argument:
%Y(t) = [dlog(y(t)/h(t)) log(h(t)) log(i(t)/y(t)) log(c(t)/y(t))]'
%
%Y(t) = [dlog(y(t)) log(h(t)) log(i(t)/y(t)) log(c(t)/y(t))]'

if nargin < 11
    def=1;
end

n=size(B,2);
tau=zeros(1,n);
tau(1)=1;

AA=A(1,1);
h0=A(2,1);
h1=B(2,:);
BB=B(1,:);

[yk,ys,ik,is,ck,cs] = rrform(h0,h1,AA,BB,theta,delta,muz,k,c,y,l,gam);

i=((1+gam)-(1-delta)*exp(-muz))*k;

a0=[muz log(l) log(i/y) log(c/y)]';
a1=[theta*(1-h0) h0 ik-yk ck-yk]';
a2=[-theta*(1-h0) 0 0 0]';

b0=[(1-theta)*tau-theta*h1
    h1
    is-ys
    cs-ys];
b1=[theta*(tau+h1)
    zeros(3,n)];

if def == 2

    a1(1)=yk;
    a2(1)=-yk;
    b0(1,:)=tau+ys;
    b1(1,:)=-ys;  
    
end