function [Y] = rnd(T,p,q,N,sarcoef,macoef,v)

%this simulates data from a SARMA model

randn('state',1);
Y=[];
qp= max(p,q);
Y([1:qp+1],[1:N])=zeros(qp+1,N);
u([1:qp+1],[1:N])=zeros(qp+1,N);
c=chol(v)';
u([qp+2:qp+1+T],[1:N])=randn(T,N)*c';

%[V] = getV(u([qp+2:qp+1+T],:));%useful for debugging, V should be same as v

for ii = qp+2:qp+1+T
    aa=zeros(1,N);
    for jj = 1:p
        aa=aa+sarcoef(jj)*Y(ii-jj,:);
    end
    aa=aa+u(ii,:);
    for jj = 1:q
        aa=aa+u(ii-jj,:)*(macoef(:,(jj-1)*N+[1:N])');
    end
    Y(ii,:)=aa;
end

Y=Y([qp+2:qp+1+T],:);
