%this computes the plims for different p's
close all
clear all
setpath

%load up the parameter values:
paramsnew

%delta=1;
%sig=6;
lam=1600;
def=1;%this determines the definition of X(t) in constructing a0, a1, a2, b0, b1, see rform.m
tau=[1 0
         1 1
         1  0];%specifies that investment responds to everything and labor only to second shock.
     
tau=ones(3,2);

%J=[1 2 ];
lngrun=1;%if = 1, do longrun identification; if = 0, do short run, if = 2, do long run, but use true zero-frequency spectral density
iplt=2;%if 1 graph results just for first p case, %if 2 look at several lag lengths as once
chk=0;%check all analytic derivatives used to solve the model, by evaluating the numerical analogs
f=4;
f=[];

% J=[1 2];
% JJ=[1 2 3];
% T=1000;
% [P] = simszha(theta,muz,taux,beta,delta,gamma,taul,psi,lb,rhoz,rhox,rhol,tau,sigz,sigl,sigx,sig,J,JJ,T,def);

%&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
if max(max(tau==0)) < 1 & lngrun == 0
    error('fatal (run) trying to do recursive identification in a model where it is not satisfied')
end

if abs(sig-1) < .1e-9
    
    [A,B,P,a0,a1,a2,b0,b1,W,y,l,c,k] = solution(theta,muz,taux,beta,delta,gamma, ...
        taul,psi,lb,rhoz,rhox,rhol,tau,sigz,sigl,sigx,sig,chk,def);
    
else%if sig ~= 1, then compute the value of psi that rationalizes the steady state employment at sig = 1
    
    ssig=1;
    [A,B,P,a0,a1,a2,b0,b1,W,y,l,c,k] = solution(theta,muz,taux,beta,delta,gamma, ...
        taul,psi,lb,rhoz,rhox,rhol,tau,sigz,sigl,sigx,ssig,chk,def);
    ll=l;
    [A,B,P,a0,a1,a2,b0,b1,W,y,l,c,k,psi] = solution(theta,muz,taux,beta,delta,gamma, ...
        taul,psi,lb,rhoz,rhox,rhol,tau,sigz,sigl,sigx,sig,chk,def,ll);
    
end 

if abs(sig) < .1e-10
    frisch=Inf;
else
    frisch=(lb-l)/(sig*l);
end

h0=A(2,1);
h1=B(2,:);
A=A(1,1);
B=B(1,:);

T=100;
if length(J) <= 3
    %get parameters of VAR(infinity)
    [M,varcoef,C,Bsum,Bsumchk] = sargentvillaverde(theta,muz,taux,beta,delta,gamma, ...
        taul,psi,lb,rhoz,rhox,rhol,sigz,sigl,sigx,P,sig,tau,J,T,def);

    for ii = 1:T
        B11(ii)=varcoef(1,1,ii);
        B12(ii)=varcoef(1,2,ii);
        B21(ii)=varcoef(2,1,ii);
        B22(ii)=varcoef(2,2,ii);
    end
end

epsil=zeros(length(B),T);
epsil(1,1)=sigz;
[khat,lhat,s] = simulmodel(epsil,A,B,P,h0,h1,T);
yltrue=theta*(khat([1:end-1])-s(1,:))+(1-theta)*lhat-lhat;
z=cumsum(s(1,:));
Yltrue=yltrue+z;

pltt=0;
if pltt == 1    
    subplot(211)
    plot(100*Yltrue)
    title('Labor Productivity')
    subplot(212)
    plot(100*lhat)
    title('Hours Worked')
    hout=suptitle('Response of Hours Worked and Labor Productivity in Benchmark CKM Example')
    return
end

N=1000;
p=4;
Tt=[];
[bbet4,C4,V4,rrts,Y4,Isum4,Q4,S4,v4,v41] = getmodelvar(T,N,p,lam,muz,l,k,c,y,theta,delta,h0,h1,A,B,P,sigz,sigl,sigx,J,f,lngrun,Tt);
sprintf('std dev of output = %5.3f, rel std of l = %5.2f, rel std of c = %5.3f, rel std of i = %5.3f, corr, y/l and l = %5.3f\n',sqrt(v4(1)), ...
    sqrt(v4(7)/v4(1)),sqrt(v4(4)/v4(1)),sqrt(v4(3)/v4(1)),v4(5)/sqrt(v4(2)*v4(6)))
sprintf('percent of hp-filtered variance in output due to technology = %6.5f\n',100*v41(1)/v4(1))
sprintf('percent of variance in log employment due to technology = %6.5f\n',100*v41(2)/v4(2))
sprintf('percent of variance in hp-filtered log employment due to technology = %6.5f\n',100*v41(7)/v4(1))
pp(1)=p;


if iplt == 2

    p=25;
    [bbet8,C8,V8,rrts,Y8,Isum8,Q8] = getmodelvar(T,N,p,lam,muz,l,k,c,y,theta,delta,h0,h1,A,B,P,sigz,sigl,sigx,J,f,lngrun,Tt);
    pp=[pp p];

    p=50;
    [bbet16,C16,V16,rrts,Y16,Isum16,Q16] = getmodelvar(T,N,p,lam,muz,l,k,c,y,theta,delta,h0,h1,A,B,P,sigz,sigl,sigx,J,f,lngrun,Tt);
    pp=[pp p];

    p=60;
    [bbet32,C32,V32,rrts,Y32,Isum32,Q32] = getmodelvar(T,N,p,lam,muz,l,k,c,y,theta,delta,h0,h1,A,B,P,sigz,sigl,sigx,J,f,lngrun,Tt);
    pp=[pp p];
    
end

getvarmatrices


figure
subplot(221)
plot([1:pp(1)],B411,[1:pp(2)],B811,[1:pp(3)],B1611,[1:pp(4)],B3211,[1:T],B11)
title('B11')
axis([0 60 -.15 .02])
subplot(222)
plot([1:pp(1)],B412,[1:pp(2)],B812,[1:pp(3)],B1612,[1:pp(4)],B3212,[1:T],B12)
title('B12')
subplot(223)
plot([1:pp(1)],B421,[1:pp(2)],B821,[1:pp(3)],B1621,[1:pp(4)],B3221,[1:T],B21)
title('B21')
subplot(224)
plot([1:pp(1)],B422,[1:pp(2)],B822,[1:pp(3)],B1622,[1:pp(4)],B3222,[1:T],B22)
title('B22')
A4=[sum(B411) sum(B412);sum(B421) sum(B422)];
A8=[sum(B811) sum(B812);sum(B821) sum(B822)];
A16=[sum(B1611) sum(B1612);sum(B1621) sum(B1622)];
A32=[sum(B3211) sum(B3212);sum(B3221) sum(B3222)];



checksolve=0;
if checksolve == 1
    checkmodel%run the AER 1992 model for comparison
end

figure
T=T-1;
tt=0:T-1;
tj=1:T;
if iplt == 1
    subplot(211)
    plot(tt(tj),100*lhat(tj),'*',tt(tj),100*Y4(2,tj),tt(tj),100*lhat(tj))    
    title('Response of Hours Worked (True Response *)')
    Ylhat=cumsum(Y4(1,tj));
    subplot(212)
    plot(tt(tj),100*Ylhat(tj),tt(tj),100*Yltrue(1,tj),'*',tt(tj),100*Yltrue(tj))    
    title('Response of Productivity (True Response *)')
    
    adjust=Yltrue(end)/Ylhat(end);
%     subplot(222)
%     plot(tt(tj),100*lhat(tj)*adjust,'*',tt(tj),100*Y4(2,tj),tt(tj),100*lhat(tj)*adjust)    
%     title('Response of Hours Worked (True Response *)')
%     Ylhat=cumsum(Y4(1,tj));
%     subplot(224)
%     plot(tt(tj),100*Ylhat(tj)*adjust,tt(tj),100*Yltrue(1,tj),'*',tt(tj),100*Yltrue(tj))    
%     title('Response of Productivity (True Response *)')
else
    plot(tt(tj),100*lhat(tj),'*',tt(tj),100*Y4(2,tj),tt(tj),100*lhat(tj),tt(tj),100*Y8(2,tj),tt(tj),100*lhat(tj),tt(tj),100*Y16(2,tj),tt(tj),100*Y32(2,tj),tt(tj),100*lhat(tj))
    title('Response of Hours Worked, Analytic Plims, for Lag Length p = 4, 50, 70, 80; True Response *')
    %axis([0 19 0 .7])
end

if iplt == 1;return;end

pp=[pp inf];
tt=1:5;
xx=[Y4(2,tt);Y8(2,tt);Y16(2,tt);Y32(2,tt);lhat(tt)]*100;
xx=[xx pp'];