function [P] = simszha(theta,muz,taux,beta,delta,gamma,taul,psi,lb,rhoz,rhox,rhol,tau,sigz,sigl,sigx,sig,J,JJ,T,def)

% These calculations are suggested by the work done in section 3 of
% Sims-Zha's Macroeconomic Dynamics (forthcoming) paper.
%
% There's still a bug in here....this is because the initial uncertainty
% about the shocks is set to their variance, which surely must be an upper
% bound. But, with more data the uncertainty goes up, which must be wrong.
%
% This computes a sequence, P=[P1,P2,P3,...,PT];
%
%  Pt = var(e(t) - P[e(t)|y(1),...,y(t)]),
%
% where P denotes linear projection using the Kalman filter.
% 
% def determines what data are contained in y(t)
%    
%JJ selects which fundamental economic shocks we're working with. You must work with
%the technology shock and hours worked. You can work with one, both or none
%of the other two shocks.

[H,F,D,Qt,n] = stateobserver(theta,muz,taux,beta,delta,gamma,taul,psi,lb,rhoz,rhox,rhol,tau,sigz,sigl,sigx,sig,J,JJ,def);

%the shocks are added on to the end of the state

[m1,m2]=size(F);
FF=zeros(m1+length(JJ),m2+length(JJ));
FF([1:m1],[1:m2])=F;
F=FF;
D([m1+1:m1+length(JJ)],:)=eye(length(JJ));

H(:,[m1+1:m1+length(JJ)])=zeros(size(H,1),length(JJ));

P10=eye(size(F,2));

Q=D*D';

for ii = 1:1000
    P10=F*P10*F'+Q;
end

for ii = 1:T    
    P11=P10-P10*H'*(inv(H*P10*H'))*H*P10;
    P(:,(ii-1)*length(JJ)+[1:length(JJ)])=P11([m1+[1:length(JJ)]],[m1+[1:length(JJ)]]);
    P10=F*P11*F'+Q;
end
  