%time series model: x(t) = rho*x(t-1) + epsilon(t) + thet*epsilon(t-1)
rho=.99;
thet=-.4;
sig=.01;
randn('seed',1);
T=280;%the first 100 observations are dropped before analysis
nsim=100;%number of simulations to do.

for jj = 1:nsim
    
    epsil=randn(T,1)*sig;
    x(1)=0;
    for ii = 2:T
        x(ii)=rho*x(ii-1)+epsil(ii)+thet*epsil(ii-1);
    end
    
    tt=100:T;
    tt1=99:T-1;
    a=cov(x(tt),x(tt1));
    rhohat(jj)=a(1,2)/a(2,2);
    sighat(jj)=std(x(tt)-rhohat(jj)*x(tt1));
    imp(jj,:)=[1 rhohat(jj) rhohat(jj)^2 rhohat(jj)^3]*sighat(jj);
    
end

mimp=mean(imp);
truimp=[1 rho+thet rho*(rho+thet) rho*rho*(rho+thet)]*sig;

ts=1:4;
plot(ts,mimp,ts,truimp,'*',ts,truimp)
legend('mean','true')
dd=T-100;
ss=['number of data points in simulation = ',num2str(dd),', \rho = ',num2str(rho),', \theta = ',num2str(thet),' \sigma = ',num2str(sig)];
title(ss)