clear
close all
option=3;%option: if =0, then do X=[dlog(Y) log(labor) dlog(Inv) dlog(C)], 
                %= 1 then X=[dlog(Y) log(labor) log(Inv/Y) log(C/Y)]
                %= 3, then X=[dlog(Y/labor) log(labor) dlog(Inv) dlog(C)]
                
sht=1;%if = 1 or 2, then use only output growth and labor and set meas error=0,(if=1, cev data, =2, ckm data)
      % if = 0 use all four variables, cev data
      % if= 3, use the first three variables, estimate the parameters of
      % technology, preferences and capital taxes. No measurement error.
      % Use cev data
      
const = 0;
rv=0;%=1, use vigfusson's program to get the initial estimates of the sarma model
         %=0, use the model to get the initial estimates
datasource=1;%if =1, then use actual data, otherwise, generate random data using model parameters in paramsnew 

setpath
paramsnew

tau=ones(3,2);%specifies that all decisions see all shocks...the rest of the code assumes this

[Y] = getdata(option,sht);

if const == 0%if no constant is to be used in the analysis, then take mean out of the data
    mm=mean(Y');
    [m,T]=size(Y);    
    for ii = 1:m
        Y(ii,:)=Y(ii,:)-ones(1,T)*mm(ii);
    end
end

%this is the unrestricted reduced form model (estimated in runSARMA, with
%cev data and spectral approximation to likelihood function - see fitting.m)
load reducedform ar ma vv

%ckm's june baseline
    rhol=.952;
    sigz=.0131;
    sigl=.0136;
    vl=sigl^2/(1-rhol^2);
   rhol=.995;
    sigl=sqrt(vl*(1-rhol^2));
    %sigl=0.016;

[sarcoef,macoef,v,q,p] = inp(theta,muz,taux,beta,delta,gamma,taul,psi,lb,rhoz,rhox,rhol,tau,sigz,sigl,sigx,sig,rv);

cut=60*4;%10 years
[lamckm,Crlckm,Crhckm,Culckm,Cuhckm,likerckm,likeuckm,Frckm,Fuckm,per,omm,VARuckm,VARrckm,omegackm] = ...
    decompose(Y,sarcoef,macoef,v,q,p,ar,ma,vv,cut);

varCKM=Crlckm+Crhckm;
vdprod=Crlckm(1,1)/varCKM(1,1);
vhours=Crlckm(2,2)/varCKM(2,2);

varuCKM=Culckm+Cuhckm;
vudprod=Culckm(1,1)/varuCKM(1,1);
vuhours=Culckm(2,2)/varuCKM(2,2);

%estimation results with cev data, frequency approximation to gaussian likelihood (see fitting.m)
    rhol =   0.98800310347395;
    sigl =  0.00577685270699;
    sigz =  0.00957495833237;
    rhoz=.0;
    
[sarcoef,macoef,v,q,p] = inp(theta,muz,taux,beta,delta,gamma,taul,psi,lb,rhoz,rhox,rhol,tau,sigz,sigl,sigx,sig,rv);

if length(ar) < p | size(ma,2) < q
    ar(p)=0;
    ma(:,4+[1:2])=zeros(2,2);
end
  
[lamkp,Crlkp,Crhkp,Culkp,Cuhkp,likerkp,likeukp,Frkp,Fukp,perkp,omm,VARukp,VARrkp,omegakp] = ...
    decompose(Y,sarcoef,macoef,v,q,p,ar,ma,vv,cut);

varKP=Crlkp+Crhkp;
vdprodkp=Crlkp(1,1)/varKP(1,1);
vhourskp=Crlkp(2,2)/varKP(2,2);

varuKP=Culkp+Cuhkp;
vudprodkp=Culkp(1,1)/varuKP(1,1);
vuhourskp=Culkp(2,2)/varuKP(2,2);

sprintf(' cutoff low frequences - have period longer than %5.2f years\n',cut/4)
sprintf(' fraction of variance in productivity growth in low frequencies, KP (unrestricted) = %5.3f (%5.3f)',vdprodkp,vudprodkp)
sprintf(' fraction of variance in log hours in low frequencies, KP (unrestricted) = %5.3f (%5.3f)',vhourskp,vuhourskp)
sprintf(' fraction of variance in productivity growth in low frequencies, CKM (unrestricted) = %5.3f (%5.3f)',vdprod,vudprod)
sprintf(' fraction of variance in log hours in low frequencies, CKM (unrestricted) = %5.3f (%5.3f)',vhours,vuhours)

subplot(221)
plot(omm,lamckm,omm,lamkp)
legend('CKM Baseline','KP Baseline')
title('likelihood ratio statistic')
axis tight

subplot(222)
plot(omm,lamkp)
legend('CKM Baseline','KP Baseline')
title('likelihood ratio statistic, KP model only')
axis tight

subplot(223)
plot(omm,log(real(squeeze(Frckm(1,1,:)))),'o',omm,log(real(squeeze(Frkp(1,1,:)))),'*',omm,log(real(squeeze(Fuckm(1,1,:)))), ...
    omm,log(real(squeeze(Frkp(1,1,:)))),omm,log(real(squeeze(Frckm(1,1,:)))))
legend('CKM Baseline','KP Baseline','Unrestricted')
title('productivity growth')
ylabel('log, spectrum')
axis tight

subplot(224)
plot(omm,log(real(squeeze(Frckm(2,2,:)))),'o',omm,log(real(squeeze(Frkp(2,2,:)))),'*',omm,log(real(squeeze(Fuckm(2,2,:)))), ...
    omm,log(real(squeeze(Frkp(2,2,:)))),omm,log(real(squeeze(Frckm(2,2,:)))))
legend('CKM Baseline','KP Baseline','Unrestricted')
title('log, hours')
ylabel('log, spectrum')
axis tight

tt=1:28;
tt=1:length(omm);
t1=2:length(omm);
figure
subplot(211)

plot(omm(tt),log(real(squeeze(Frckm(1,1,tt))/varCKM(1,1))),'o',omm(tt),log(real(squeeze(Frkp(1,1,tt)))/varKP(1,1)),'*', ...
    omm(tt),log(real(squeeze(Fuckm(1,1,tt)))/varuCKM(1,1)),'+',omm(tt),log(real(squeeze(Frkp(1,1,tt)))/varKP(1,1)), ...
    omm(tt),log(real(squeeze(Frckm(1,1,tt)))/varCKM(1,1)),omm(tt),log(real(squeeze(Fuckm(1,1,tt)))/varuCKM(1,1)))
legend('CKM Baseline','KP Baseline','SARMA')
title('productivity growth')
ylabel('log, normalized spectrum')
axis tight

subplot(212)
plot(omm(tt),log(real(squeeze(Frckm(2,2,tt)))/varCKM(2,2)),'o',omm(tt),log(real(squeeze(Frkp(2,2,tt)))/varKP(2,2)),'*', ...
    omm(tt),log(real(squeeze(Fuckm(2,2,tt)))/varuCKM(2,2)),'+',omm(tt),log(real(squeeze(Frkp(2,2,tt)))/varKP(2,2)),omm(tt), ...
    log(real(squeeze(Frckm(2,2,tt)))/varCKM(2,2)),omm(tt),log(real(squeeze(Fuckm(2,2,tt)))/varuCKM(2,2)))
legend('CKM Baseline','KP Baseline','SARMA')
title('log, hours')
ylabel('log, normalized spectrum')
axis tight


figure 
subplot(211)

tt=1:100;
tt=1:length(VARrckm(1,1,:));

plot(omegakp(tt),(real(squeeze(VARrckm(1,1,tt))/varCKM(1,1))),'*',omegakp(tt),(real(squeeze(VARrkp(1,1,tt)))/varKP(1,1)),'-.', ...
    omegakp(tt),(real(squeeze(VARuckm(1,1,tt)))/varuCKM(1,1)),'+',omegakp(tt),(real(squeeze(VARrkp(1,1,tt)))/varKP(1,1)), ...
    omegakp(tt),(real(squeeze(VARrckm(1,1,tt)))/varCKM(1,1)),omegakp(tt),(real(squeeze(VARuckm(1,1,tt)))/varuCKM(1,1)))
legend('CKM Baseline','KP Baseline','SARMA')
title('productivity growth')
ylabel('Fraction of Variance Concentrated in Lower Frequencies')
%axis tight
%axis([0 pi .0 1.0])
axis([0 .8 0. .25])

subplot(212)
plot(omegakp(tt),(real(squeeze(VARrckm(2,2,tt))/varCKM(2,2))),'*',omegakp(tt),(real(squeeze(VARrkp(2,2,tt)))/varKP(2,2)),'-.', ...
    omegakp(tt),(real(squeeze(VARuckm(2,2,tt)))/varuCKM(2,2)),'+',omegakp(tt),(real(squeeze(VARrkp(2,2,tt)))/varKP(2,2)), ...
    omegakp(tt),(real(squeeze(VARrckm(2,2,tt)))/varCKM(2,2)),omegakp(tt),(real(squeeze(VARuckm(2,2,tt)))/varuCKM(2,2)))
legend('CKM Baseline','KP Baseline','SARMA')
title('log, hours')
ylabel('Fraction of Variance Concentrated in Lower Frequencies')
%axis([0 pi 0 .2])
axis([0 .8 0 1])
