%this studies the spectrum of a model
close all
clear all
setpath

%load up the parameter values:
params
lam=1600;
tau=[1 0
         1 1
         1  0];%specifies that investment responds to everything and labor only to second shock.
tau=ones(3,2);

chk=0;%check all analytic derivatives used to solve the model, by evaluating the numerical analogs
f=4;
f=[];

%&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

[A,B,P,a0,a1,a2,b0,b1,W,y,l,c,k] = solution(theta,muz,taux,beta,delta,gamma, ...
    taul,psi,lb,rhoz,rhox,rhol,tau,sigz,sigl,sigx,sig,chk);
frisch=(lb-l)/(sig*l);

h0=A(2,1);
h1=B(2,:);
A=A(1,1);
B=B(1,:);

N=1000;
p=4;

if length(J) > rank(W)
    error('fatal (getmodelvar) more variables than shocks in VAR')
end

%go get the VAR asociated with the function passed through findAR.
[bbet,V,S,v] = findAR(p,N,W,lam,J,f,'dee',A,a1,a2,b0,b1,B,P);
WW=W;
WW(2,2)=0;
[bbet1,V1,S1,v1] = findAR(p,N,WW,lam,J,f,'dee',A,a1,a2,b0,b1,B,P);


for ii = 1:(N/2)
    omeg(ii)=2*pi*ii/N;
    L=exp(-i*omeg(ii));
    SS=zeros(2,size(S,1));
    SS(1,1)=1/(1-L);
    SS(2,2)=1;
    SS(1,2)=1;
    Spect(:,:,ii)=SS*S(:,:,ii+1)*SS';
    Spect1(:,:,ii)=SS*S1(:,:,ii+1)*SS';
end

[Y,I]=min(abs(omeg-2*pi/32));
[Y,I1]=min(abs(omeg-2*pi/12));

tt=I:I1;

plot(omeg(tt),(real(squeeze(Spect(1,1,tt)))),omeg(tt),(real(squeeze(Spect1(1,1,tt)))),'*',omeg(tt),(real(squeeze(Spect1(1,1,tt)))))
ylabel('Spectrum')
xlabel('frequency, from 2\pi/32 to 2\pi/12 (''Business Cycle Frequencies'')')
axis tight
if par == 1
    title('KP Model, Spectral Density With Both Shocks and Spectral Density With Only Technology Shocks (*)')
elseif par == 2
    title('CKM Model, Spectral Density With Both Shocks and Spectral Density With Only Technology Shocks (*)')
end



