function [y,l,c,k,A] = sstate(theta,muz,taux,beta,delta,gamma,taul,psi,lbar,sig)

kl=((theta*exp(muz*(1-theta))/(1+taux))/(exp(muz)/beta-(1-delta)))^(1/(1-theta));
A=((exp(-muz)*kl)^theta-((1+gamma)-(1-delta)*exp(-muz))*kl);
B=((1-taul)*(1-theta)/psi)*(kl*exp(-muz))^theta;

if abs(sig-1) > .1e-10
    options=[];
    [x,fval,exitflag] = fzero('findssl',[.0001 lbar-.0001],options,lbar,A,B,sig);
    if exitflag ~= 1
        error('fatal (sstate) failed to find steady state for hours')
    end
    if abs(fval) > .1e-10
        error('fatal (sstate) did not find accurate solution for steady state hours')
    end
    l=x;
else
    l=B*lbar/(A+B);
end

c=A*l;
k=kl*l;
y=((exp(-muz)*k)^theta)*(l^(1-theta));

err=y-c-(1+gamma)*k+(1-delta)*exp(-muz)*k;
if abs(err) > .1e-10
    error('fatal (sstate) consistency check in sstate failed')
end

err=(1+taux)-beta*exp(-muz)*(theta*((exp(-muz)*kl)^(theta-1))+(1+taux)*(1-delta));
if abs(err) > .1e-10
    error('fatal (sstate) consistency check on intertemporal euler equation failed')
end
