clear all
close all
setpath
addpath c:\projects\solve\TimeSeriesAnalysis
paramsnew

%dbstop in mykalman at 39
if abs(sig-1) > .1e-10
    error('fatal (statespace) program not equipped to handle sig different from unity')
end

%parameter settings for optimization routine:
option=0;%if =1, then do cointegration
sht=2;%if = 1 or 2, then use only output growth and labor and set meas error=0,(if=1, cev data, =2, ckm data)
      % if = 0 use all four variables
      % if= 3, use the first three variables, estimate the parameters of
      % technology, preferences and capital taxes. No measurement error.
const=0;%if = 0, then do not estimate constant term
stderr=1;%if = 1, then compute standard errors
maxiter=20000;%max number of iterations for optimization
measerr=1;%=1, estimate measurement error, = 0, just keep it fixed at RR
mcg=0;%if unity, then override all other parameters and run mcgrattan's code


%go get the data
[Y] = getdata(option,sht);
sarlags=2;
malags=3;
mm=mean(Y');
[m,T]=size(Y);
RR=eye(m,m)*.001;

rrhol=rhol;
ssigl=sigl;
ssigz=sigz;
rrhox=rhox;
ssigx=sigx;



if mcg == 1
    
    ver=4;%if = 1 estimate ellen's version, with four variables and restricted measurement error
    %if = 2 estimate with four variables with measurement error variance free
    %if = 3 estimate with measurement error fixed, but only three variables
    %if = 4 estimate with free measurement error and three variables.
    %Theta = muz, taul, rhol, sigz, sigl
    Theta=[0.00315978734958
        0.24145195522122
        0.94030218142799
        0.00568074748817
        0.00800035329731];
%     Theta=[0.00422635915240;
%       0.25111483007157;
%       0.97445836125723;
%       0.01222242383455;
%       0.00620779295648;];
     
    R       = 1e-4*eye(4);
    if ver == 2;for ii = 1:4;Theta(5+ii)=sqrt(R(ii,ii));end;end
    if ver == 4;for ii = 1:3;Theta(5+ii)=sqrt(R(ii,ii));end;end  
    dummy=[];
    ckmdata
    global ZVAR
    ZVAR=VARdat(:,2:end);
    dg=diff(ZVAR(:,4));
    tt=2:length(dg);
    t1=1:length(dg)-1;
    a=corrcoef(dg(tt),dg(t1));
    err=dg(tt)-a(1,2)*dg(t1);
    ste=std(err);
    if ver >= 3
        ZVAR=ZVAR(:,1:end-1);
    end
    
    
    
    
    [L,Sbar,P0,P,Q,A,B,C,param,innov,MY,DY,MX] = mleq_ur_2s(Theta,dummy,ver);
    
    optionals = optimset('LevenbergMarquardt','on','Display','iter','TolFun',1e-8,'TolX',1e-8,'MaxFun',maxiter,'Diagnostics','on','MaxFunEvals',maxiter,'MaxIter',maxiter);
    [Thetanew,fval,exitflag] = fminsearch(@mleq_ur_2s,Theta,optionals,dummy,ver)
    [L,Sbar,P0,P,Q,A,B,C,param,innov,MY,DY,MX] = mleq_ur_2s(Thetanew,dummy,ver);     
    
else
    
    rhol =   0.99603831976432;
    sigl =    0.00536767273950;
    sigz =   0.00778084685544;
    
    [rhol,sigl,sigz,rhox,sigx,R,se,Hess,fval,xx,Yout] = estimatemodel(Y,theta,muz,taux,beta,delta,gamma,taul,psi,lb,rhoz,rrhox,ssigx, ...
        RR,rrhol,ssigl,ssigz,option,sht,const,stderr,measerr,maxiter);
    
    t1=170;
    L=0;
    
    restr=1;
    [floglik,H,F,W,R,init_V] = ckm(xx,Yout,theta,muz,taux,beta,delta,gamma,taul,psi,lb,rhoz,rhox,sigx,rhol,sigl,RR,option,restr);
    
    [Yhat,VYhat] = forecastkalman(Yout,H,F,W,R,init_V,t1,L);
    
    dates=1959.50:.25:2001.75;
    subplot(221)
    plot(dates,Yout(1,:),dates,Yhat(1,:))
    title('Output Growth')
    axis tight
    subplot(222)
    plot(dates,Yout(2,:),dates,Yhat(2,:))
    title('hours worked')
    axis tight
    if m == 4
        subplot(223)
        plot(dates,Yout(3,:),dates,Yhat(3,:))
        legend('data','model')
        title('Investment Growth')
        axis tight
        subplot(224)
        plot(dates,Yout(4,:),dates,Yhat(4,:))
        title('Consumption Growth')
        axis tight
    end
    
end