function [sarcoef,macoef,v] = stepone(data,p,q)
%this is the first step in the maximum likelihood routine for estimating a
%SARMA model

N=size(data,2);
hascon=0;
[sarcoef,macoef,const,erz]=estsvar(data,p,q,hascon);

[ip] = checkroot(sarcoef,macoef,p,q);

if ip == 1
    error('fatal (stepone) estimated process not stationary')
end
if ip == 2
    error('fatal (stepone) estimated process not invertible')
end
if ip == 3
    error('fatal (stepone) estimated process not stationary or invertible')
end

[v] = getV(erz);

pp=length(sarcoef);
qq=size(macoef,2)/N;
if round(qq)*N ~= size(macoef,2) | pp ~= p
    error('fatal (estimateSARMA) surprise in output from estvar')
end  